#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/02/91";
#endif
#define YYBYACC 1
#line 2 "readcomfile.y"

# include <stdio.h>
# include "regexp.h"
# include "instr.h"

/* We may use builtin alloca */
#include "compatible.h"
#ifdef _NEEDALLOCAH_
#  include <alloca.h>
#endif

static char *comfile;             /* name of command file        */
static char *errstring;           /* token that caused the error */
static int lineno  = 0;           /* input linenumber            */
static FILE *infile;              /* input filepointer           */
static int noError = TRUE;        /* input error indicator       */

extern void addCommand (int command, REXP *file, REXP *class, REXP *func);

#line 23 "readcomfile.y"
typedef union
{
  struct
  {
    char *string;
    int   num;
  }
  term;

  struct
  {
    REXP *file;
    REXP *class;
    REXP *func;
  }
  nonterm;

  REXP *rexp;

  LIMIT lmt;
} YYSTYPE;
#line 48 "y.tab.c"
#define T_AND 257
#define T_CHILDREN 258
#define T_CLASS 259
#define T_COUNT 260
#define T_EXCLUDE 261
#define T_FILE 262
#define T_FUNCTION 263
#define T_INCLUDE 264
#define T_ONLY 265
#define T_OR 266
#define T_SMALLER 267
#define T_STATEMENTS 268
#define T_THAN 269
#define Identifier 270
#define Number 271
#define RegExpression 272
#define T_EOC 273
#define T_COLON 274
#define T_DBL_COLON 275
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    7,    7,    7,    7,    1,    1,    1,    3,
    3,    3,    3,    5,    5,    4,    4,    4,    4,    4,
    4,    4,    8,    8,    6,    6,    9,    9,    2,    2,
};
short yylen[] = {                                         2,
    2,    0,    2,    3,    1,    2,    1,    1,    1,    2,
    2,    2,    1,    1,    1,    5,    3,    4,    3,    2,
    2,    1,    3,    2,    7,    7,    1,    0,    1,    1,
};
short yydefred[] = {                                      2,
    0,    0,    0,    0,    8,    9,    5,    0,    1,    0,
    6,   27,    0,    0,   24,    0,    0,    0,   14,   15,
    0,   13,    0,    3,   23,    0,   11,   10,   12,    4,
    0,    0,    0,    0,   17,    0,    0,    0,   29,   30,
    0,    0,   16,    0,    0,   26,   25,
};
short yydgoto[] = {                                       1,
    8,   41,   21,   22,   23,   15,    9,   10,   13,
};
short yysindex[] = {                                      0,
 -253, -268, -240, -255,    0,    0,    0, -249,    0, -247,
    0,    0, -255, -237,    0, -266, -266, -266,    0,    0,
 -234,    0, -244,    0,    0, -238,    0,    0,    0,    0,
 -266, -266, -239, -241,    0, -248, -248, -266,    0,    0,
 -233, -231,    0, -232, -217,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0, -225, -235,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -230,    0,    0,    0,    0,    0,    0,    0,
 -229, -228,    0, -227,    0,    0,    0, -226,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,   11,    0,    0,  -16,   36,    0,    0,    0,
};
#define YYTABLESIZE 49
short yytable[] = {                                      27,
   28,   29,    2,   19,   11,   20,    3,    4,   39,   16,
    5,   14,   17,   18,   34,   35,    6,   40,   36,    7,
   19,   43,   20,    7,   12,   24,    7,    7,   37,   31,
   32,   26,   33,   38,    7,   46,    7,   44,   30,   45,
   47,   28,   22,   20,   21,   19,   18,   42,   25,
};
short yycheck[] = {                                      16,
   17,   18,  256,  270,  273,  272,  260,  261,  257,  259,
  264,  267,  262,  263,   31,   32,  270,  266,  258,  273,
  270,   38,  272,  259,  265,  273,  262,  263,  268,  274,
  275,  269,  271,  275,  270,  268,  272,  271,  273,  271,
  258,  267,  273,  273,  273,  273,  273,   37,   13,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 275
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_AND","T_CHILDREN","T_CLASS",
"T_COUNT","T_EXCLUDE","T_FILE","T_FUNCTION","T_INCLUDE","T_ONLY","T_OR",
"T_SMALLER","T_STATEMENTS","T_THAN","Identifier","Number","RegExpression",
"T_EOC","T_COLON","T_DBL_COLON",
};
char *yyrule[] = {
"$accept : Commands",
"Commands : Commands Commandline",
"Commands :",
"Commandline : LimitCommand T_EOC",
"Commandline : ExclInclCommand Parameter T_EOC",
"Commandline : T_EOC",
"Commandline : error T_EOC",
"ExclInclCommand : T_EXCLUDE",
"ExclInclCommand : T_INCLUDE",
"ExclInclCommand : Identifier",
"Parameter : T_FILE Name",
"Parameter : T_CLASS Name",
"Parameter : T_FUNCTION Name",
"Parameter : QualifiedName",
"Name : Identifier",
"Name : RegExpression",
"QualifiedName : Name T_COLON Name T_DBL_COLON Name",
"QualifiedName : Name T_DBL_COLON Name",
"QualifiedName : Name T_COLON Name T_DBL_COLON",
"QualifiedName : Name T_COLON Name",
"QualifiedName : Name T_COLON",
"QualifiedName : Name T_DBL_COLON",
"QualifiedName : Name",
"LimitCommand : T_COUNT OptOnly Limit",
"LimitCommand : T_EXCLUDE Limit",
"Limit : T_SMALLER T_THAN Number T_STATEMENTS LogOp Number T_CHILDREN",
"Limit : T_SMALLER T_THAN Number T_CHILDREN LogOp Number T_STATEMENTS",
"OptOnly : T_ONLY",
"OptOnly :",
"LogOp : T_AND",
"LogOp : T_OR",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 600
#define YYMAXDEPTH 600
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 280 "readcomfile.y"

int yyerror (char *msg)
{
  if ( strcmp (msg, "syntax error") != 0 )
  {
    fprintf (stderr, "%s[%2d]: yacc %s\n", comfile, lineno+1, msg);
    exit (1);
  }
  errstring = yylval.term.string;
}

void regerror (char *msg)
{
  fprintf (stderr, "%s[%2d]: regular expression error: %s\n",
           comfile, lineno+1, msg);
  noError = FALSE;
}

# if defined(sequent) || defined(butterfly)
char *bsearch (key, base, nel, size, compar)
char *key;
char *base;
int nel;
int size;
int (*compar) ();
{
  int i;

  for (i=0; i<nel; i++)
  {
    if ( (* compar) (key, base) == 0 ) return (base);
    base += size;
  }
  return (NULL);
}
# else
extern char *bsearch();
# endif


# define MAXSYMBOL 15

static struct symbol
{
  int   Token;      /* key word token number */
  char *Name;       /* key word              */
}
Symbols[MAXSYMBOL] =
{
  T_AND,        "and",
  T_CHILDREN,   "child",
  T_CHILDREN,   "children",
  T_CLASS,      "class",
  T_COUNT,      "count",
  T_EXCLUDE,    "exclude",
  T_FILE,       "file",
  T_FUNCTION,   "function",
  T_INCLUDE,    "include",
  T_ONLY,       "only",
  T_OR,         "or",
  T_SMALLER,    "smaller",
  T_STATEMENTS, "statement",
  T_STATEMENTS, "statements",
  T_THAN,       "than"
};

static int symbolCompare (struct symbol *s1, struct symbol *s2)
{
  return ( strcmp (s1->Name, s2->Name) );
}

static char *strSave (char *string)
{
  char *res;

  res = xalloc (strlen(string)+1, char);
  strcpy (res, string);
  return (res);
}

static int isSymbol (char *string, char **name)
{
  struct symbol *ptr;    /* -- pointer to element found --------------------- */
  struct symbol  symb;   /* -- element to search ---------------------------- */

  symb.Name = string;
  /* -- binary search in key word table (Symbols) --------------------------- */
  ptr = (struct symbol *) bsearch ((char *) (&symb),
                                   (char *) Symbols,
                                   MAXSYMBOL,
                                   sizeof(struct symbol),
                                   symbolCompare
                                  );
  if (ptr == NULL)
  {
    /* -- not found ------------------------------------ */
    *name = strSave (string);
    return (Identifier);
  }
  else
  {
    /* -- found: return key word token number ---------- */
    *name = ptr->Name;
    return (ptr->Token);
  }
}
static int ch;                      /* scanner character buffer      */
static int getnext = TRUE;          /* scanner lookahead indicator   */
static char  inbuf[256];            /* scanner input buffer          */

# define S 3
# define D 2
# define X 1
# define n 0

static char validch[] = {           /* valid identifier characters   */
/*      !  "  #  $  %  &  '  (  )  *  +  ,  -  .  /   */
        X, X, n, X, X, X, X, X, X, X, X, X, X, X, X,
/*   0  1  2  3  4  5  6  7  8  9  :  ;  <  =  >  ?   */
     D, D, D, D, D, D, D, D, D, D, n, X, n, X, n, X,
/*   @  A  B  C  D  E  F  G  H  I  J  K  L  M  N  O   */
     X, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S,
/*   P  Q  R  S  T  U  V  W  X  Y  Z  [  \  ]  ^  _   */
     S, S, S, S, S, S, S, S, S, S, S, X, X, X, X, X,
/*   `  a  b  c  d  e  f  g  h  i  j  k  l  m  n  o   */
     X, S, S, S, S, S, S, S, S, S, S, S, S, S, S, S,
/*   p  q  r  s  t  u  v  w  x  y  z  {  |  }  ~      */
     S, S, S, S, S, S, S, S, S, S, S, X, X, X, X
};

# define ISVALID(ch,op,val) ((ch > ' ') && (ch <= '~') && (validch[ch - '!'] op val))

# undef X
# undef n

int yylex ()
{
  int i, n;

  do
  {
    if ( getnext ) ch = getc (infile);

    if ( ISVALID(ch,==,S) )
    {
      i = 0;
      do
      {
        inbuf[i++] = ch;
        ch = getc (infile);
      }
      while ( ISVALID(ch,>,0) );
      inbuf[i++] = '\0';
      getnext = FALSE;
      return ( yylval.term.num = isSymbol (inbuf, &yylval.term.string) );
    }
    else if ( ISVALID(ch,==,D) )
    {
      i = n = 0;
      do
      {
        inbuf[i++] = ch;
        n = n*10 + ch - '0';
        ch = getc (infile);
      }
      while ( ISVALID(ch,==,D) );
      inbuf[i++] = '\0';
      getnext = FALSE;
      yylval.term.num = n;
      yylval.term.string = strSave (inbuf);
      return ( Number );
    }
    else if (ch == '<')
    {
      getnext = TRUE;
      i = 0;
      while ( (ch = getc(infile)) != EOF )
      {
        if ( ch == '>' ) break;
        if ( ch == '\n' )
        {
          fprintf (stderr, "%s[%2d]: unterminated regular expression\n",
                   comfile, lineno+1);
          noError = FALSE;
          getnext = FALSE;
          break;
        }
        inbuf[i++] = ch;
      }
      inbuf[i++] = '\0';
      yylval.term.string = strSave (inbuf);
      return ( yylval.term.num = RegExpression );
    }
    else if (ch == ':')
    {
      if ( (ch = getc(infile)) != ':' )
      {
        getnext = FALSE;
        yylval.term.string = ":";
        return ( yylval.term.num = T_COLON );
      }
      else
      {
        getnext = TRUE;
        yylval.term.string = "::";
        return ( yylval.term.num = T_DBL_COLON );
      }
    }
    else
    {
      getnext = TRUE;
      switch ( ch )
      {
        case EOF : return ( 0 );
        case '#' : while ( getc(infile) != '\n' );   /* comment */
        case '\n': lineno++;
                   return ( T_EOC );
        default  : /* skip */
                   break;
      }
    }
  }
  while ( ch != EOF );

  return (0);
}

int readComFile (char *filename)
{
  comfile = filename;
  if ( (infile = fopen (comfile, "r")) == NULL )
  {
    perror (comfile);
    exit (1);
  }
  yyparse ();
  fclose (infile);
  return (noError);
}
#line 438 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 4:
#line 88 "readcomfile.y"
{
      if ( noError )
      {
        addCommand (yyvsp[-2].term.num, yyvsp[-1].nonterm.file, yyvsp[-1].nonterm.class, yyvsp[-1].nonterm.func);
      }
    }
break;
case 5:
#line 96 "readcomfile.y"
{}
break;
case 6:
#line 99 "readcomfile.y"
{
      fprintf (stderr, "%s[%2d]: invalid commandline [near %s]\n",
               comfile, lineno, errstring);
      noError = FALSE;
      yyerrok;
    }
break;
case 7:
#line 109 "readcomfile.y"
{
      yyval.term.string = yyvsp[0].term.string;
      yyval.term.num    = COM_EXCLUDE;
    }
break;
case 8:
#line 115 "readcomfile.y"
{
      yyval.term.string = yyvsp[0].term.string;
      yyval.term.num    = COM_INCLUDE;
    }
break;
case 9:
#line 121 "readcomfile.y"
{
      yyval.term.string = yyvsp[0].term.string;
      yyval.term.num    = COM_NULL;

      fprintf (stderr, "%s[%2d]: invalid command `%s'\n",
               comfile, lineno+1, yyvsp[0].term.string);
      noError = FALSE;
      yyerrok;
    }
break;
case 10:
#line 134 "readcomfile.y"
{
      yyval.nonterm.file  = yyvsp[0].rexp;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = RNULL;
    }
break;
case 11:
#line 141 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = yyvsp[0].rexp;
      yyval.nonterm.func  = RNULL;
    }
break;
case 12:
#line 148 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = yyvsp[0].rexp;
    }
break;
case 13:
#line 155 "readcomfile.y"
{
      yyval.nonterm = yyvsp[0].nonterm;
    }
break;
case 14:
#line 162 "readcomfile.y"
{
      yyval.rexp = xalloc (1, REXP);
      yyval.rexp->regexpr = (regexp *) 0;
      yyval.rexp->regstr  = yyvsp[0].term.string;
    }
break;
case 15:
#line 169 "readcomfile.y"
{
      yyval.rexp = xalloc (1, REXP);
      yyval.rexp->regexpr = regcomp (yyvsp[0].term.string);
      yyval.rexp->regstr  = yyvsp[0].term.string;
    }
break;
case 16:
#line 178 "readcomfile.y"
{
      yyval.nonterm.file  = yyvsp[-4].rexp;
      yyval.nonterm.class = yyvsp[-2].rexp;
      yyval.nonterm.func  = yyvsp[0].rexp;
    }
break;
case 17:
#line 185 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = yyvsp[-2].rexp;
      yyval.nonterm.func  = yyvsp[0].rexp;
    }
break;
case 18:
#line 192 "readcomfile.y"
{
      yyval.nonterm.file  = yyvsp[-3].rexp;
      yyval.nonterm.class = yyvsp[-1].rexp;
      yyval.nonterm.func  = RNULL;
    }
break;
case 19:
#line 199 "readcomfile.y"
{
      yyval.nonterm.file  = yyvsp[-2].rexp;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = yyvsp[0].rexp;
    }
break;
case 20:
#line 206 "readcomfile.y"
{
      yyval.nonterm.file  = yyvsp[-1].rexp;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = RNULL;
    }
break;
case 21:
#line 213 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = yyvsp[-1].rexp;
      yyval.nonterm.func  = RNULL;
    }
break;
case 22:
#line 220 "readcomfile.y"
{
      yyval.nonterm.file  = RNULL;
      yyval.nonterm.class = RNULL;
      yyval.nonterm.func  = yyvsp[0].rexp;
    }
break;
case 23:
#line 229 "readcomfile.y"
{
      count_limit.stmts = yyvsp[0].lmt.stmts;
      count_limit.child = yyvsp[0].lmt.child;
      count_limit.op    = yyvsp[0].lmt.op;
    }
break;
case 24:
#line 236 "readcomfile.y"
{
      excl_limit.stmts = yyvsp[0].lmt.stmts;
      excl_limit.child = yyvsp[0].lmt.child;
      excl_limit.op    = yyvsp[0].lmt.op;
    }
break;
case 25:
#line 245 "readcomfile.y"
{
      yyval.lmt.stmts = yyvsp[-4].term.num;
      yyval.lmt.child = yyvsp[-1].term.num;
      yyval.lmt.op    = yyvsp[-2].term.num;
    }
break;
case 26:
#line 252 "readcomfile.y"
{
      yyval.lmt.stmts = yyvsp[-1].term.num;
      yyval.lmt.child = yyvsp[-4].term.num;
      yyval.lmt.op    = yyvsp[-2].term.num;
    }
break;
case 27:
#line 261 "readcomfile.y"
{}
break;
case 28:
#line 264 "readcomfile.y"
{}
break;
case 29:
#line 269 "readcomfile.y"
{
      yyval.term.num = OP_AND;
    }
break;
case 30:
#line 274 "readcomfile.y"
{
      yyval.term.num = OP_OR;
    }
break;
#line 780 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
